SoImage Class Reference

| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoImage Class Reference
Node Classes

The SoImage class draws a 2D image on the viewport.An image can be specified either by using the image field, or by specifying a filename. If width and or height is specified, the image will be resized to match those values before it is displayed. More...

`#include <Inventor/nodes/SoImage.h>`

Inheritance diagram for SoImage:

## Public Types
enum | VertAlignment { BOTTOM, HALF, TOP }
enum | HorAlignment { LEFT, CENTER, RIGHT }
Public Types inherited from SoShape
enum | TriangleShape { TRIANGLE_STRIP, TRIANGLE_FAN, TRIANGLES, POLYGON, QUADS, QUAD_STRIP, POINTS, LINES, LINE_STRIP }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoImage (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoShape
virtual SbBool | affectsState (void) const
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | callback (SoCallbackAction *action)
const SoBoundingBoxCache * | getBoundingBoxCache (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | doAction (SoAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
uint32_t | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoShape
static SoType | getClassTypeId (void)
static void | initClass (void)
static void | getScreenSize (SoState *const state, const SbBox3f &boundingbox, SbVec2s &rectsize)
static float | getDecimatedComplexity (SoState *state, float complexity)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFInt32 | width
SoSFInt32 | height
SoSFEnum | vertAlignment
SoSFEnum | horAlignment
SoSFImage | image
SoSFString | filename

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoImage ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (SbBool flag)
Protected Member Functions inherited from SoShape
| SoShape (void)
virtual | ~SoShape ()
float | getComplexityValue (SoAction *action)
virtual SbBool | shouldGLRender (SoGLRenderAction *action)
void | beginSolidShape (SoGLRenderAction *action)
void | endSolidShape (SoGLRenderAction *action)
void | GLRenderBoundingBox (SoGLRenderAction *action)
SbBool | shouldPrimitiveCount (SoGetPrimitiveCountAction *action)
SbBool | shouldRayPick (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action, const SbMatrix &matrix)
virtual SoDetail * | createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)
virtual SoDetail * | createLineSegmentDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, SoPickedPoint *pp)
virtual SoDetail * | createPointDetail (SoRayPickAction *action, const SoPrimitiveVertex *v, SoPickedPoint *pp)
void | invokeTriangleCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2, const SoPrimitiveVertex *const v3)
void | invokeLineSegmentCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2)
void | invokePointCallbacks (SoAction *const action, const SoPrimitiveVertex *const v)
void | beginShape (SoAction *const action, const TriangleShape shapetype, SoDetail *const detail=NULL)
void | shapeVertex (const SoPrimitiveVertex *const v)
void | endShape (void)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoTextureCoordinateElement *const tce, const float s, const float t, const SbVec3f &normal)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoTextureCoordinateElement *const tce, const float s, const float t, const float r, const SbVec3f &normal)
SbBool | startVertexArray (SoGLRenderAction *action, const SoCoordinateElement *coords, const SbVec3f *pervertexnormals, const SbBool texpervertex, const SbBool colorpervertex)
void | finishVertexArray (SoGLRenderAction *action, const SbBool vbo, const SbBool normpervertex, const SbBool texpervertex, const SbBool colorpervertex)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoShape
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoImage class draws a 2D image on the viewport.

An image can be specified either by using the image field, or by specifying a filename. If width and or height is specified, the image will be resized to match those values before it is displayed.

The current modelview matrix will be used to find the viewport position, and the image is rendered in that position, with z-buffer testing activated.

Here's a simple, stand-alone example on how to set up and show an SoImage:

#include <stdlib.h>
#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoImage.h>
static void
mandel(double sr, double si, double width, double height,
int bwidth, int bheight, int mult, unsigned char * bmp, int n)
{
double zr, zr_old, zi, cr, ci;
int w;
for (int y=0; y<bheight; y++)
for (int x=0; x<bwidth; x++) {
cr = ((double)(x)/(double)(bwidth))*width+sr;
ci = ((double)(y)/(double)(bheight))*height+si;
zr = zi = 0.0;
for (w = 0; (w < n) && (zr*zr + zi*zi)<n; w++) {
zr_old = zr;
zr = zr*zr - zi*zi + cr;
zi = 2*zr_old*zi + ci;
}
bmp[y*bwidth+x] = w*mult;
}
}
int
main(int argc, char ** argv)
{
QWidget * mainwin = SoQt::init(argv[0]);
SoSeparator * root = new SoSeparator;
root->ref();
const int IMGWIDTH = 256;
const int IMGHEIGHT = 256;
unsigned char * img = new unsigned char[IMGWIDTH * IMGHEIGHT];
mandel(-0.5, 0.6, 0.025, 0.025, IMGWIDTH, IMGHEIGHT, 1, img, 256);
SoImage * nimage = new SoImage;
nimage->vertAlignment = SoImage::HALF;
nimage->horAlignment = SoImage::CENTER;
nimage->image.setValue(SbVec2s(IMGWIDTH, IMGHEIGHT), 1, img);
SoCube * cube = new SoCube;
root->addChild(cube);
root->addChild(nimage);
SoQtExaminerViewer * viewer = new SoQtExaminerViewer(mainwin);
viewer->setSceneGraph(root);
viewer->setTitle("SoImage use");
viewer->show();
SoCamera * cam = viewer->getCamera();
cam->position = SbVec3f(0, 0, 50);
cam->focalDistance = 50;
SoQt::show(mainwin);
SoQt::mainLoop();
delete viewer;
root->unref();
delete img;
return 0;
}

Note that an SoImage node in the scene graph will have it's positioning / rendering influenced by the current viewport and camera. This has important implications for how to layout your scene graph for the best possible rendering performance. See the note about this issue in the SoText2 class documentation.

SoScale nodes can not be used to influence the dimensions of the rendering output of SoImage nodes.

FILE FORMAT/DEFAULTS:

Image {
width -1
height -1
vertAlignment BOTTOM
horAlignment LEFT
image 0 0 0
filename ""
}

Since
  TGS Inventor 2.5
  Coin 1.0

## Member Enumeration Documentation

enum SoImage::VertAlignment

Vertical alignment for image.

Enumerator
BOTTOM | Vertical alignment at bottom of image.
HALF | Vertical alignment at center of image.
TOP | Vertical alignment at top of image.

enum SoImage::HorAlignment

Horizontal alignment for image.

Enumerator
LEFT | Horizontal alignment at left border.
CENTER | Horizontal alignment at center of image.
RIGHT | Horizontal alignment ar right border.

## Constructor & Destructor Documentation

SoImage::SoImage | ( | void |  | ) |

Constructor.

SoImage::~SoImage | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

SoType SoImage::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoShape.

const SoFieldData * SoImage::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoShape.

void SoImage::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoShape.

void SoImage::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Calculates picked point based on primitives generated by subclasses.

Reimplemented from SoShape.

void SoImage::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |
| virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables.

Reimplemented from SoShape.

void SoImage::generatePrimitives | ( | SoAction * | action | ) |
| protectedvirtual

Will generate a textured quad, representing the image in 3D.

Implements SoShape.

void SoImage::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) |  |
| protectedvirtual

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

SbBool SoImage::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoImage::notify | ( | SoNotList * | l | ) |
| protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoShape.

int SoImage::getReadStatus | ( | void |  | ) |
| protected

Returns TRUE if node was read ok.

void SoImage::setReadStatus | ( | SbBool | flag | ) |
| protected

Set read status for this node.

## Member Data Documentation

SoSFInt32 SoImage::width

If bigger than 0, resize image to this width before rendering. Default value is -1 (ie "don't resize").

SoSFInt32 SoImage::height

If bigger than 0, resize image to this height before rendering. Default value is -1 (ie "don't resize").

SoSFEnum SoImage::vertAlignment

Vertical alignment. Default value is SoImage::BOTTOM.

SoSFEnum SoImage::horAlignment

Horizontal alignment. Default value is SoImage::LEFT.

SoSFImage SoImage::image

Inline image data. Default empty.

SoSFString SoImage::filename

Image filename. Default empty.

The documentation for this class was generated from the following files:

- SoImage.h
- SoImage.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.